diff --git a/game/client/src/main/java/net/minecraft/client/util/helper/ScreenshotHelper.java b/game/client/src/main/java/net/minecraft/client/util/helper/ScreenshotHelper.java
index 820e2d145..87889a252 100644
--- a/game/client/src/main/java/net/minecraft/client/util/helper/ScreenshotHelper.java
+++ b/game/client/src/main/java/net/minecraft/client/util/helper/ScreenshotHelper.java
@@ -3,6 +3,7 @@ package net.minecraft.client.util.helper;
 import static net.minecraft.core.util.helper.Buffer.*;
 import static org.lwjgl.opengl.ARBFramebufferObject.*;
 import static org.lwjgl.opengl.GL11.*;
+import static org.lwjgl.opengl.GL12.GL_CLAMP_TO_EDGE;
 
 import java.awt.Graphics;
 import java.awt.image.BufferedImage;
@@ -11,8 +12,7 @@ import java.io.File;
 import javax.imageio.ImageIO;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.render.FallbackRenderer;
-import net.minecraft.client.render.Framebuffer;
+import net.minecraft.client.render.FrameBuffer;
 import net.minecraft.client.render.Renderer;
 import net.minecraft.client.render.texture.Texture;
 import net.minecraft.core.Global;
@@ -22,12 +22,12 @@ public class ScreenshotHelper {
 	
 	public final Minecraft minecraft;
 	
-	private final Framebuffer framebuffer = new Framebuffer();
+	private final FrameBuffer framebuffer = new FrameBuffer();
 	private final Texture colortex = new Texture();
 	private final Texture depthtex = new Texture();
 	
-	private int width = 1024;
-	private int height = 1024;
+	private final int width = 1024;
+	private final int height = 1024;
 	
 	private float fov;
 	private float yaw;
@@ -45,19 +45,17 @@ public class ScreenshotHelper {
 		try {
 			setup();
 			takeScreenshot();
-		}catch (Exception e) {
-			throw e;
-		}finally {
+		} finally {
 			delete();
 		}
 	}
 	
 	private void takeScreenshot() throws Exception {
-		minecraft.gameSettings.FoV.value = 0.6056338f; //90 Degrees
-		minecraft.thePlayer.yRot = 0.0f;
-		minecraft.thePlayer.xRot = 0.0f;
-		minecraft.thePlayer.yRotO = minecraft.thePlayer.yRot;
-		minecraft.thePlayer.xRotO = minecraft.thePlayer.xRot;
+        this.minecraft.gameSettings.FoV.value = 0.6056338f; //90 Degrees
+        this.minecraft.thePlayer.yRot = 0.0f;
+        this.minecraft.thePlayer.xRot = 0.0f;
+        this.minecraft.thePlayer.yRotO = this.minecraft.thePlayer.yRot;
+        this.minecraft.thePlayer.xRotO = this.minecraft.thePlayer.xRot;
 		
 //		minecraft.entityRenderer.renderWorld(0, 0);
 		
@@ -68,22 +66,22 @@ public class ScreenshotHelper {
 		File[] files = new File[4];
 		
 		for(int i=0; i < 4; i++) {
-			minecraft.thePlayer.yRot = i * 90f;
-			minecraft.thePlayer.yRotO = minecraft.thePlayer.yRot;
-			
-			minecraft.worldRenderer.updateCameraAndRender(0);
+            this.minecraft.thePlayer.yRot = i * 90f;
+            this.minecraft.thePlayer.yRotO = this.minecraft.thePlayer.yRot;
+
+            this.minecraft.worldRenderer.updateCameraAndRender(0);
 			
-			BufferedImage image = Textures.getTextureAsImage(colortex.id(), false, 0, true);
+			BufferedImage image = Textures.getTextureAsImage(this.colortex.id(), false, 0, true);
 			File file = new File(screenshotFolder, now + "-" + i + ".png");
 			Textures.saveImage(file, image);
 			files[i] = file;
 		}
 		
-		BufferedImage image = new BufferedImage(width * 4, height, BufferedImage.TYPE_INT_RGB);
+		BufferedImage image = new BufferedImage(this.width * 4, this.height, BufferedImage.TYPE_INT_RGB);
 		Graphics g = image.getGraphics();
 		
 		for(int i=0; i < files.length; i++) {
-			g.drawImage(ImageIO.read(files[i]), width * i, 0, null);
+			g.drawImage(ImageIO.read(files[i]), this.width * i, 0, null);
 		}
 		
 		g.dispose();
@@ -92,55 +90,55 @@ public class ScreenshotHelper {
 	}
 	
 	public void setup() {
-		framebuffer.generate();
-		colortex.generate();
-		depthtex.generate();
+        this.framebuffer.generate();
+        this.colortex.generate();
+        this.depthtex.generate();
 		
-		Buffer.checkBufferSize(width * height * 4);
+		Buffer.checkBufferSize(this.width * this.height * 4);
 		Buffer.reset();
-		
-		framebuffer.bind();
-		
-		colortex.bind();
-		glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, width, height, 0, GL_RGBA, GL_UNSIGNED_BYTE, buffer);
+
+        this.framebuffer.bind();
+
+        this.colortex.bind();
+		glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, this.width, this.height, 0, GL_RGBA, GL_UNSIGNED_BYTE, buffer);
 		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
 		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
-		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
-		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
-		glFramebufferTexture2D(GL_FRAMEBUFFER, GL_COLOR_ATTACHMENT0, GL_TEXTURE_2D, colortex.id(), 0);
-		
-		depthtex.bind();
-		glTexImage2D(GL_TEXTURE_2D, 0, GL_DEPTH_COMPONENT, width, height, 0, GL_DEPTH_COMPONENT, GL_UNSIGNED_BYTE, buffer);
+		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
+		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
+		glFramebufferTexture2D(GL_FRAMEBUFFER, GL_COLOR_ATTACHMENT0, GL_TEXTURE_2D, this.colortex.id(), 0);
+
+        this.depthtex.bind();
+		glTexImage2D(GL_TEXTURE_2D, 0, GL_DEPTH_COMPONENT, this.width, this.height, 0, GL_DEPTH_COMPONENT, GL_UNSIGNED_BYTE, buffer);
 		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
 		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
-		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
-		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
-		glFramebufferTexture2D(GL_FRAMEBUFFER, GL_DEPTH_ATTACHMENT, GL_TEXTURE_2D, depthtex.id(), 0);
-		
-		fov = minecraft.gameSettings.FoV.value;
-		yaw = minecraft.thePlayer.yRot;
-		pitch = minecraft.thePlayer.xRot;
-		renderer = minecraft.renderer;
-		oldWidth = minecraft.gameWindow.getWidthPixels();
-		oldHeight = minecraft.gameWindow.getHeightPixels();
-		immersiveMode = minecraft.gameSettings.immersiveMode.value;
-		minecraft.gameSettings.immersiveMode.value = 2;
+		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
+		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
+		glFramebufferTexture2D(GL_FRAMEBUFFER, GL_DEPTH_ATTACHMENT, GL_TEXTURE_2D, this.depthtex.id(), 0);
 
-		minecraft.renderer = new FallbackRenderer(minecraft);
+        this.fov = this.minecraft.gameSettings.FoV.get();
+        this.yaw = this.minecraft.thePlayer.yRot;
+        this.pitch = this.minecraft.thePlayer.xRot;
+        this.renderer = this.minecraft.renderer;
+        this.oldWidth = this.minecraft.gameWindow.getWidthPixels();
+        this.oldHeight = this.minecraft.gameWindow.getHeightPixels();
+        this.immersiveMode = this.minecraft.gameSettings.immersiveMode.value;
+        this.minecraft.gameSettings.immersiveMode.value = 2;
+
+//		minecraft.renderer = new FallbackRenderer(minecraft);
 	}
 	
 	public void delete() {
 		glBindFramebuffer(GL_FRAMEBUFFER, 0);
-		
-		framebuffer.delete();
-		colortex.delete();
-		depthtex.delete();
-		
-		minecraft.gameSettings.FoV.value = fov;
-		minecraft.thePlayer.yRot = yaw;
-		minecraft.thePlayer.xRot = pitch;
-		minecraft.renderer = renderer;
-		minecraft.gameSettings.immersiveMode.value = immersiveMode;
+
+        this.framebuffer.delete();
+        this.colortex.delete();
+        this.depthtex.delete();
+
+        this.minecraft.gameSettings.FoV.value = this.fov;
+        this.minecraft.thePlayer.yRot = this.yaw;
+        this.minecraft.thePlayer.xRot = this.pitch;
+        this.minecraft.renderer = this.renderer;
+        this.minecraft.gameSettings.immersiveMode.value = this.immersiveMode;
 	}
 	
 }
diff --git a/game/client/src/main/java/net/minecraft/client/util/helper/Textures.java b/game/client/src/main/java/net/minecraft/client/util/helper/Textures.java
index 7094b1476..5cf5452c2 100644
--- a/game/client/src/main/java/net/minecraft/client/util/helper/Textures.java
+++ b/game/client/src/main/java/net/minecraft/client/util/helper/Textures.java
@@ -21,6 +21,7 @@ import it.unimi.dsi.fastutil.ints.IntList;
 import net.minecraft.client.render.texture.stitcher.AtlasStitcher;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.util.helper.Buffer;
+import org.jetbrains.annotations.NotNull;
 import org.lwjgl.opengl.GL12;
 
 import com.b100.utils.ImageUtils;
@@ -31,8 +32,7 @@ import org.slf4j.Logger;
 
 public class Textures {
 	private static final Logger LOGGER = LogUtils.getLogger();
-	public final static BufferedImage missingTexture;
-	
+	public final static @NotNull BufferedImage missingTexture;
 	static {
 		missingTexture = new BufferedImage(64, 64, BufferedImage.TYPE_INT_ARGB);
 		
diff --git a/game/client/src/main/java/org/useless/dragonfly/models/block/StaticBlockModel.java b/game/client/src/main/java/org/useless/dragonfly/models/block/StaticBlockModel.java
index 4c3804439..4d8d941fb 100644
--- a/game/client/src/main/java/org/useless/dragonfly/models/block/StaticBlockModel.java
+++ b/game/client/src/main/java/org/useless/dragonfly/models/block/StaticBlockModel.java
@@ -2,7 +2,8 @@ package org.useless.dragonfly.models.block;
 
 import net.minecraft.client.render.block.color.BlockColor;
 import net.minecraft.client.render.block.model.BlockModel;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
+import net.minecraft.client.render.tessellator.TessellatorTerrain;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.Side;
@@ -16,12 +17,12 @@ public interface StaticBlockModel {
     /**
      * @return True if anything rendered, false otherwise
      */
-    boolean renderStandalone(@NotNull BlockModel<? extends BlockLogic> sourceModel, @NotNull Tessellator tessellator, double x, double y, double z, int metadata, @NotNull BlockColor color, float brightness, float alpha);
+    boolean renderStandalone(@NotNull BlockModel<? extends BlockLogic> sourceModel, @NotNull TessellatorGeneral tessellator, double x, double y, double z, int metadata, @NotNull BlockColor color);
 
     /**
      * @return True if anything rendered, false otherwise
      */
-    boolean renderAttached(@NotNull BlockModel<? extends BlockLogic> sourceModel, @NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z, double xOff, double yOff, double zOff, boolean cullFaces, @Nullable IconCoordinate overrideTexture);
+    boolean renderAttached(@NotNull BlockModel<? extends BlockLogic> sourceModel, @NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, int x, int y, int z, double xOff, double yOff, double zOff, boolean cullFaces, @Nullable IconCoordinate overrideTexture);
 
     /**
      * @return Block texture to overlay when inside a block
